'use strict';

var _ = require('lodash');
var TypeSafeMatcher = require('./TypeSafeMatcher');
var FeatureMatcher = require('./FeatureMatcher');

module.exports = function (matcherOrValue) {
	var innerMatcher = new FeatureMatcher(matcherOrValue, 'a collection or string with size', 'size', function (item) {
		return _.size(item);
	});
	return _.create(new TypeSafeMatcher(), {
		isExpectedType: function (actual) {
			return _.isString(actual) || _.isObject(actual);
		},
		matchesSafely: innerMatcher.matches,
		describeTo: innerMatcher.describeTo,
		describeMismatchSafely: innerMatcher.describeMismatch
	});
};
